@echo off
echo 0 > count.txt

@rem ========== BMC version information ==========
@set FILE_NAME=allv259.bin
@set CHECK_VER="02 59"
@set DISPLAY_VER=02.59
@rem =============================================
echo %CHECK_VER% > check.txt

IF "%1"=="1" GOTO F
IF "%1"=="3" GOTO GET
IF "%1"=="4" GOTO PRESERVE
echo Please check below usage to flash BMC by SOCflash!!
echo.
echo WARNING!! 
echo FBB 1 will not preserve BMC configuration!!
echo .
echo Please specify the BMC Flash update options following the "%0" command:
echo "%0 1": Update BMC via SOCflash without preserve configuration
echo "%0 3": Get BMC MAC 
echo "%0 4": Update BMC via SOCflash with preserve configuration
echo .
GOTO End

@rem ============================================================================
:PRESERVE
ipmitool 20 18 1 > PreID.txt
echo =============================================
echo Updating Bootloader...
echo =============================================
socflash.exe if=%FILE_NAME% skip=0 offset=0 count=0x30000
echo =============================================
sleep 5 > null
echo Updating Kernel...
echo =============================================
socflash.exe if=%FILE_NAME% skip=0x100000 offset=0x100000 count=0x1f0000
echo =============================================
sleep 5 > null
echo Updating Root file system...
echo =============================================
socflash.exe if=%FILE_NAME% skip=0x300000 offset=0x300000 count=0x1b00000
echo =============================================
echo Wait 180 seconds and check Device ID. 
echo Please do not press any key while counting down.
echo =============================================
goto check

@rem ============================================================================
:check
sleep 180 > null
ipmitool 20 18 01 > ID.txt
check.exe
if exist retry goto addcount
goto done

@rem ============================================================================
:addcount
find "5" count.txt > null
if errorlevel 1 goto 04
goto fail
:04
echo Check Device ID fail, retry again!!
find "4" count.txt > null
if errorlevel 1 goto 03
echo 5 > count.txt
goto PRESERVE
:03
find "3" count.txt > null
if errorlevel 1 goto 02
echo 4 > count.txt
goto PRESERVE
:02
find "2" count.txt > null
if errorlevel 1 goto 01
echo 3 > count.txt
goto PRESERVE
:01
find "1" count.txt > null
if errorlevel 1 goto 00
echo 2 > count.txt
goto PRESERVE
:00
find "0" count.txt > null
echo 1 > count.txt
goto PRESERVE

@rem ============================================================================
:fail
echo.
echo ===================================================
echo Update BMC to %DISPLAY_VER% and retry 5 times but still fail
echo Please try again.
echo ===================================================
goto End

@rem ============================================================================
:done
debond.exe
echo ===============================
echo Update BMC to %DISPLAY_VER% successfully
echo ===============================
goto End

@rem ============================================================================
:F
@rem [Get channel 1 MAC ]

perl bmcmt get_mac > macaddr
echo Flashing BMC...
socflash.exe if=%FILE_NAME% skip=0 offset=0 count=0x30000
sleep 5 > null
socflash.exe if=%FILE_NAME% skip=0x40000 offset=0x40000
GOTO Jump

@rem ============================================================================
:Jump
echo .
echo Please wait 180 seconds for BMC boot up.
echo Please do not press any key while counting down.
sleep 180 > null
echo ===============================
echo Update BMC to %DISPLAY_VER% successfully
echo ===============================
GOTO End


:FBB
@echo Get BMC version
ipmitool 20 18 01
@echo Entering manufacturing test mode
ipmitool 20 18 5 64 52 45 4d 24 73 74 38
@echo Flash BMC MAC ing....
perl bmcmt fix_macs < macaddr
@echo.
@echo BMC MAC address has been reset from file "macaddr"
@echo.
@echo Wait for Net Mode ready
sleep 20 > null
@echo.
@echo Rereading directly from BMC to confirm:
@echo.
perl bmcmt get_all_macs
@echo.
del macaddr.bak
@ren macaddr macaddr.bak
@echo.
@echo Check BMC nic_mode
sleep 20 > null
perl bmcmt nic_mode

GOTO End

@rem ============================================================================
:GET
@echo Check BMC MAC 
perl bmcmt get_all_macs
GOTO End

@rem ============================================================================
:End
if exist null del null
if exist count.txt del count.txt
if exist ID.txt del ID.txt
if exist check.txt del check.txt
if exist retry del retry
if exist MACaddr.txt del MACaddr.txt
if exist IPSrc.txt del IPSrc.txt
if exist IPAddr.txt del IPAddr.txt
if exist Mask.txt del Mask.txt
if exist D4GWay.txt del D4GWay.txt
if exist RID.txt del RID.txt
if exist NIC.txt del NIC.txt
if exist PreID.txt del PreID.txt